local LimitedStockBuyer = select(2, ...)
LimitedStockBuyer = LibStub("AceAddon-3.0"):NewAddon(LimitedStockBuyer,"LimitedStockBuyer", "AceConsole-3.0","AceEvent-3.0")
local AceGUI = LibStub("AceGUI-3.0")
LimitedStockBuyer.version = GetAddOnMetadata("LimitedStockBuyer", "Version")

--- Variables, for easy naming scheme and understanding where each code belongs to.
local GUI = LimitedStockBuyer
local Util = LimitedStockBuyer 

--- Enables disables printing of information. using  LimitedStockBuyer:ErrorMessage(STATEMENT)
LimitedStockBuyer.ErrorMessages = false


--- Database information ---
local savedDBDefaults = { --- Default the saved variables
	global = {
	},
}

function LimitedStockBuyer:OnInitialize()	
	--LimitedStockBuyer.db = LibStub:GetLibrary("AceDB-3.0"):New("LSBDB", savedDBDefaults, true)
	
	LimitedStockBuyer:RegisterEvent("MERCHANT_SHOW",function() if Util:CheckForLimitedSupply() then
																											C_Timer.After(0.5, LimitedStockBuyer.ToggleGUI) -- Timer allows for game time to send the Merchant items data to client before calling
																										end
																									end) 
	LimitedStockBuyer:RegisterEvent("MERCHANT_CLOSED",function() if GUI.frameOpen then -- check whether frame is open, also stops and handles double events caused by blizzard.
																											LimitedStockBuyer.ToggleGUI()
																										end
																									end)
	LimitedStockBuyer:ErrorMessage("Running in debug mode") --- if ErrorMessages enabled
end


function LimitedStockBuyer.ToggleGUI() --- Handling GUI opening and closing
	GUI:HandleFrame()
	LimitedStockBuyer.GetLimitedStock()
end

function LimitedStockBuyer.GetLimitedStock() -- gets the limited supply items from vendor
	local numMerchantItems = GetMerchantNumItems()
	local MerchCurrentCheck = 1 -- Default variable for looping
	LimitedStockBuyer.ButtonListNum = 0 -- Default number of buttons
	LimitedStockBuyer.ButtonList = {} -- Defaults the list of buttons to empty
	
	while MerchCurrentCheck <= numMerchantItems do
		local name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(MerchCurrentCheck) -- get information for each item at version [MerchCurrentCheck = Item slot on merchant]
		if numAvailable ~= -1 and Util:ItemBop(MerchCurrentCheck) == false then -- Check whether the item is a limited supply, Blizzard ID's limited supplies as -1 on the available .
			
			local itemLink = GetMerchantItemLink(MerchCurrentCheck) --- Get the link of the item for passing into TSM item tracker
			
			LimitedStockBuyer.ButtonListNum = LimitedStockBuyer.ButtonListNum+1 -- if found, increase by number of buttons by 1
			local ButtonTableHolder = { -- Create table for button
					["name"] = name,
					["texture"] = texture,
					["price"] = price,
					["quantity"] = quantity,
					["numAvailable"] = numAvailable,
					["merchItemNum"] = MerchCurrentCheck,
					["itemLink"] = itemLink
				}
			
			tinsert(LimitedStockBuyer.ButtonList,ButtonTableHolder) -- insert  Button table into ButtonList
		end
		MerchCurrentCheck = MerchCurrentCheck+1 -- Increase the merchant check number.
	end
	
	GUI:CreateFrameItems() --- Create the button frames from GUI.lua
end

function LimitedStockBuyer:ErrorMessage(STATEMENT) -- Standard error messaging information
	if LimitedStockBuyer.ErrorMessages == true then
		LimitedStockBuyer:Print(STATEMENT)
	end
end


---- Not Yet Implemented below this line. ---
--[[ function LimitedStockBuyer:RunUpdateSV()
	LimitedStockBuyer.db.global.BagScale =LimitedStockBuyer.BagScaleSlider:GetValue()
	LimitedStockBuyer.db.global.BankScale =LimitedStockBuyer.BankScaleSlider:GetValue()
	LimitedStockBuyer.db.global.GBankScale =LimitedStockBuyer.GBankScaleSlider:GetValue()
	LimitedStockBuyer.db.global.VoidStorageScale =LimitedStockBuyer.VStorageScaleSlider:GetValue()
end ]]--