local LimitedStockBuyer = select(2,...)
local Util = LimitedStockBuyer
local GUI = LimitedStockBuyer

function Util:CheckForLimitedSupply() --- Checks if the vendor has limited supply items.
	local numMerchantItems = GetMerchantNumItems() 
	local MerchCurrentCheck = 1
	
	while MerchCurrentCheck <= numMerchantItems do
		local name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(MerchCurrentCheck)
		if numAvailable ~= -1 and Util:ItemBop(MerchCurrentCheck) == false then
			return true -- if limited supply available
		end
		MerchCurrentCheck = MerchCurrentCheck+1
	end
	return false --- if not limited supply available
end

function Util:ConvertItemPrice(price)
	--- Need to make neater because this is dog shite
	
	local price = price;
	local gold, copper, silver;
	local PriceString;
	
	--- complex shizz ---
	copper = price % 100
	price = (price - copper ) / 100
	silver = price % 100
	gold = (price - silver) / 100
	
	if gold >= 1 then
		PriceString = gold.."g"..silver.."s"..copper.."c";
	elseif silver >= 1 then
		PriceString = silver.."s"..copper.."c";
	elseif copper >= 1 then
		PriceString = copper.."c";
	else
	 -- Do nothing
	end
	
	return PriceString
end

function Util:BuyAllItems()
	if Util:CheckForLimitedSupply() then
		LimitedStockBuyer:Print("Buying all items")
		
		local numMerchantItems = GetMerchantNumItems() 
		local MerchCurrentCheck = 1
		
		while MerchCurrentCheck <= numMerchantItems do
			local name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(MerchCurrentCheck)
			if numAvailable ~= -1 and Util:ItemBop(MerchCurrentCheck) == false then
				LimitedStockBuyer:Print("Buying "..name.." x"..numAvailable)
				BuyMerchantItem(MerchCurrentCheck, numAvailable) -- Buys the item.
			end
			MerchCurrentCheck = MerchCurrentCheck+1
		end
		C_Timer.After(0.5,GUI.ReBuild)-- rebuilds gui when finished
	end
end

--- Tool Tip Scanning
local f = CreateFrame('GameTooltip', 'MerchTooltip', UIParent, 'GameTooltipTemplate') -- Create a tool tip frame
f:Hide() -- Hide It
function Util:ItemBop(merchantIndex)
	local Items = {}
	f:SetOwner(UIParent, 'ANCHOR_NONE') -- Always Set when scanning
	
	f:SetMerchantItem(merchantIndex) -- Set tooltip to merchant item

	Items[1] = MerchTooltipTextLeft1:GetText() -- Scan and store lines
	Items[2] = MerchTooltipTextLeft2:GetText()
	Items[3] = MerchTooltipTextLeft3:GetText()
	Items[4] = MerchTooltipTextLeft4:GetText()
	
	for i in ipairs(Items) do 
		local text = Items[i]
		if text == ITEM_BIND_ON_PICKUP then -- Check for global bop text
			return true -- BOP
		end
	end
	return false -- Not BOP
end

--- Item's Owned ---

function Util:GetOwned(itemString)
	local itemString = itemString
	if itemString == nil then return end -- no item
	
	if TSMAPI then
		if TSMAPI.Inventory:GetTotalQuantity(itemString) then -- check if command is available
			return TSMAPI.Inventory:GetTotalQuantity(itemString) --  return command
		end
	else
		return "N/A"
	end
end




